<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" xmlns:th="http://www.thymeleaf.org">
    <head>
        <meta charset="UTF-8">
        <meta name="viewport" content="width=device-width, initial-scale=1.0">
        <title th:text="${formTitle}"></title>
        <link rel="stylesheet" href="/css/bootstrap.min.css">
        <link rel="stylesheet" href="/css/main.css">
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap-icons@1.11.3/font/bootstrap-icons.min.css">
        <script src="/js/jquery-3.7.1.min.js"></script>
        <script src="/js/main.js"></script>
        <script src="/js/bootstrap.bundle.min.js"></script>
        <script src="https://cdn.tiny.cloud/1/er5z43axiepcmayrv99pv1azh7383l7jxz42h3y3bukwvdjn/tinymce/5/tinymce.min.js" referrerpolicy="origin"></script>
    </head>

    <body>
        <header>
            <div class="navbar-wrapper">
                <!-- Navbar -->
                <nav class="navbar navbar-expand-lg">
                    <div class="container-fluid d-flex flex-column">
                        <p class="heading" style="width: 100%; margin: 0;">Products</p>
                        <span class="sub-heading mt-3" th:text="${subHeading}"></span>
                    </div>
                </nav>
                <!-- Navbar -->
            </div>

            <a href="/logout" class="btn btn-danger rounded-1 logout-button">Logout</a>
        </header>

        <th:block layout:fragment="content">
            <div class="container-fluid mt-5" id="add-product-container">
                <h2 th:text="${formTitle}"></h2>
                <hr class="m-0 mb-4 border-1">

                <form id="add-product-form" method="post" th:action="${url}" th:object="${product}" enctype="multipart/form-data">
                    <div class="form-group row mb-3">
                        <label for="productName" class="col-sm-2 col-form-label text-end fw-bold pb-0 pe-4">Product Name</label>
                        <div class="col-sm-10">
                            <input name="name" type="text" class="form-control rounded-0 p-0 border-2 fw-bold px-1"
                                   id="productName" th:value="*{name}" required>
                            <p th:if="${#fields.hasErrors('name')}" th:errors="*{name}" class="text-danger"></p>
                        </div>
                    </div>

                    <div class="form-group row mb-3">
                        <label for="unitPrice" class="col-sm-2 col-form-label text-end fw-bold pb-0 pe-4">Unit Price</label>
                        <div class="col-sm-10">
                            <input name="price" type="number" step="0.01" class="form-control rounded-0 p-0 border-2 fw-bold px-1"
                                   id="unitPrice" th:value="*{price}" required min="0">
                            <p th:if="${#fields.hasErrors('price')}" th:errors="*{price}" class="text-danger"></p>
                        </div>
                    </div>

                    <div class="form-group row mb-3">
                        <label for="unitsInStock" class="col-sm-2 col-form-label text-end fw-bold pb-0 pe-4">Units In Stock</label>
                        <div class="col-sm-10">
                            <input name="quantityInStock" type="number" th:value="*{quantityInStock != null ? quantityInStock : 0}" class="form-control rounded-0 p-0 border-2 fw-bold px-1" id="unitsInStock" required min="0">
                            <p th:if="${#fields.hasErrors('quantityInStock')}" th:errors="*{quantityInStock}" class="text-danger"></p>
                        </div>
                    </div>

                    <div class="form-group row mb-3">
                        <label for="description" class="col-sm-2 col-form-label text-end fw-bold pb-0 pe-4">Description</label>
                        <div class="col-sm-10">
                            <textarea name="description" class="form-control rounded-0 p-0 border-2 fw-bold px-1"
                                      id="description" th:text="*{description}"></textarea>
                            <p th:if="${#fields.hasErrors('description')}" th:errors="*{description}" class="text-danger"></p>
                        </div>
                    </div>

                    <div class="form-group row mb-3">
                        <label for="manufacturer" class="col-sm-2 col-form-label text-end fw-bold pb-0 pe-4">Manufacturer</label>
                        <div class="col-sm-10">
                            <select name="manufacturer" class="form-control rounded-0 p-0 border-2 fw-bold px-1" id="manufacturer" required aria-label="Default select example">
                                <option value="" selected>Select Manufacturer</option>
                                <option th:each="manufacturer : ${listManufacturer}" th:value="${manufacturer.id}"
                                        th:text="${manufacturer.name}"
                                        th:selected="${product.manufacturer == manufacturer.id}"></option>
                            </select>
                            <p th:if="${#fields.hasErrors('manufacturer')}" th:errors="*{manufacturer}" class="text-danger"></p>
                        </div>
                    </div>

                  
                

                    <div class="form-group row mb-3">
                        <label for="category" class="col-sm-2 col-form-label text-end fw-bold pb-0 pe-4">Category</label>
                        <div class="col-sm-10">
                            <select name="category" class="form-control rounded-0 p-0 border-2 fw-bold px-1" id="category" required>
                                <option value="">Select Category</option>
                                <!-- Loop through the list of categories and populate options -->
                                <option th:each="category : ${listCategory}" th:value="${category.id}"
                                        th:text="${category.name}"
                                        th:selected="${product.category == category.id}"></option>
                            </select>
                            <p th:if="${#fields.hasErrors('category')}" th:errors="*{category}" class="text-danger"></p>
                        </div>
                    </div>

                    <div class="form-group row mb-3">
                        <label class="col-sm-2 col-form-label text-end fw-bold pb-0 pe-4">Condition</label>

                        <div class="col-sm-10">
                            <div class="form-check form-check-inline p-0 me-1">
                                <input class="form-check-input m-0" type="radio" id="newCondition"
                                       name="productCondition" value="new" th:checked="*{productCondition == 'new'}" required>
                                <label class="form-check-label ms-2 me-0" for="newCondition">New</label>
                            </div>

                            <div class="form-check form-check-inline p-0 me-1">
                                <input class="form-check-input m-0" type="radio" id="oldCondition"
                                       name="productCondition" value="old" th:checked="*{productCondition == 'old'}" required>
                                <label class="form-check-label ms-2 me-0" for="oldCondition">Old</label>
                            </div>

                            <div class="form-check form-check-inline p-0 me-1">
                                <input class="form-check-input m-0" type="radio" id="refurbishedCondition"
                                       name="productCondition" value="refurbished" th:checked="*{productCondition == 'refurbished'}" required>
                                <label class="form-check-label ms-2 me-0" for="refurbishedCondition">Refurbished</label>
                            </div>

                            <p th:if="${#fields.hasErrors('productCondition')}" th:errors="*{productCondition}" class="text-danger"></p>
                        </div>
                    </div>
                    <div class="form-group row mb-4">
                        <label for="productImages" class="col-sm-2 col-form-label text-end fw-bold pb-0 pe-4">Product Image File</label>

                        <div class="col-sm-10">
                            <input name="files" type="file" class="form-control-file"
                                   id="productImages" multiple
                                   th:required="${product.manufacturer == null and product.category == null}" accept="image/*">
                            <p th:if="${#fields.hasErrors('validateImages')}" th:errors="*{validateImages}" class="text-danger"></p>

                            <!-- Lưu trữ danh sách index của ảnh đã tồn tại -->
                            <div class="indexExistingImages">
                                <input type="hidden" th:each="image, iterStat : ${product.existingImages}"
                                       th:attr="data-image-id=${iterStat.index}"
                                       name="indexExistingImages" th:value="${iterStat.index}">
                            </div>

                            <div id="imagePreview" class="row mt-3">
                                <!-- Hiển thị ảnh đã tồn tại -->
                                <th:block th:each="image, iterStat : ${product.existingImages}">
                                    <div class="image-container col-md-2" th:attr="data-image-id=${iterStat.index}">
                                        <img th:src="'data:image/png;base64,' + ${image}" alt="Product Image"
                                             class="img-thumbnail"
                                             style="width: 100%; height: 170px; margin-right: 10px; object-fit: cover"/>
                                        <button type="button" class="btn btn-danger btn-sm remove-image-btn mt-2 mb-3"
                                                th:attr="data-image-id=${iterStat.index}" style="width: 100%;">Remove</button>
                                    </div>
                                </th:block>
                            </div>
                        </div>
                    </div>

                    <div class="form-group row mb-4">
                        <div class="col-sm-10 offset-sm-2">
                            <button id="addProductBtn" type="submit" class="btn btn-success rounded-1" th:text="${buttonSubmit}"></button>
                        </div>
                    </div>
                </form>
            </div>
        </th:block>
    </body>
</html>

<script>
    // Init TinyMCE
    tinymce.init({
        selector: 'textarea',
        height: 500, // 500px
        plugins: 'advlist autolink lists link image charmap print preview hr anchor pagebreak textcolor',
        toolbar: "undo redo | formatselect | bold italic underline strikethrough | alignleft aligncenter alignright alignjustify | bullist numlist outdent indent | link image | forecolor backcolor",
        menubar: 'file edit view insert format tools table help',
        content_style: 'body { font-family: Arial, sans-serif; font-size: 14px }'
    });

    // Remove images in product.existingImages
    $(document).on('click', '.remove-image-btn', function() {
        const imageId = $(this).data('imageId');

        // Remove the image from the product.existingImages list
        // Find the index of imageId in the existingImages array
        var deleteExistingImage = $('input[data-image-id="' + imageId + '"]');
        deleteExistingImage.remove();

        // Remove the image display
        const imageContainer = $('.image-container[data-image-id="' + imageId + '"]');
        if (imageContainer.length) {
            imageContainer.remove();
        }
    });

    $('#productImages').on('change', function() {
        const imagePreview = $('#imagePreview');
        const imageContainersChoosed = $('.image-container[data-image-id^="new-"]');

        // Remove newly displayed images from the previous file selection
        imageContainersChoosed.each(function() {
            $(this).remove();
        });

        const newFiles = Array.from(this.files);

        // Preview new images
        $.each(newFiles, function(index, file) {
            const reader = new FileReader();
            reader.onload = function(e) {
                const div = $('<div></div>');
                div.addClass('image-container col-md-2');
                div.attr('data-image-id', 'new-' + index);

                const img = $('<img>');
                img.attr('src', e.target.result);
                img.addClass('img-thumbnail mb-2');
                img.css({
                    width: '100%',
                    height: '170px',
                    objectFit: 'cover',
                    marginRight: '10px'
                });

                div.append(img);
                imagePreview.append(div);
            };
            reader.readAsDataURL(file);
        });
    });
</script>